2 xuehaiwuya1212 xuehaiwuya1212 于 2015.07.14 13:28 提问

关于JNI,为什么在android 4.4运行正常的程序,在4.0上运行就报错了

事情是这样的:
本身项目是基于android 4.4.2、JDK1.7 编译的,然后公司要求最低版本。
然后我将项目改成了android 2.3.3、JDK1.6编译,修改一些内容后,编译通过,在android 4.4.2的手机上运行正常。
但是现在市场部反应,在低于4.1.X的版本上运行还是有问题,因此我找来一台android 4.0.4内核的手机调试,确实报错了,在JNI模块。
报:UnsatisfiedLinkError,找不到调用的那个Native对应在C中的方法,现在我该怎么办?
android 4.4.x和android4.1.x在JNI上面有什么改变?
既然我程序在4.4.2运行成功,证明代码上没有问题,编译也没有问题,那么问题到底出在哪里??

2个回答

xuehaiwuya1212
xuehaiwuya1212   2015.07.20 14:30
已采纳

这个问题我才解决掉,原因是因为在Application.mk里面,多加了一个APP_STL := stlport_shared,然而这个stlport_shared是空的,也不知道他们当时拿来做什么,就是因为这个为空,导致我的主so加载失败,也导致了这个问题。
经过这个问题,让我学到了要认真看每一句log,因为它们真的非常有用!!如果我早点看到那句log,这些问题都不会发生了。而且对jni这块不熟悉,也是导致拖了那么久的原因。

Arnold9009
Arnold9009   2015.07.14 14:33

代码混淆的时候,不要混淆native方法

xuehaiwuya1212
xuehaiwuya1212 代码混淆没有做啊,现在程序还在裸奔
2 年多之前 回复
Csdn user default icon
上传中...
上传图片
插入图片